******************************************************************
* File:   ABP_ORDE.PRG                                           * 
* Date:   3-09-91 at 1:55p                                       *
* Note:   Procedure file for screen format ORDERS.FMT            *
* Author: Michael Liczbanski, Spectrum Data Design               *
* Notice: Copyright (c) 1991 Spectrum Data Design                *
* This code has been generated by AB_FORM2.GEN, screen format    *
* generator for dBase IV, which is part of AFTERBURNER (a series *
* of modified templates developed by Spectrum Data Design)       *
*                                                                * 
* Assumes: DBHEAP set at 85                                      *
******************************************************************

** This code uses two .dbf files: Orders.dbf and Customer.dbf
** The lookup field in Customer is cust_code
** The GET field is ord_cus in Orders.dbf

* Calling code
@  3, 21 GET ord_cus PICTURE "@! XXXXXXXXXX";
         VALID CustCode()
READ

FUNCTION CustCode
* BROWSE pick list routines for field Orders->Ord_cust
* Lookup field Customer->Cust_code   ORDER Cust_code
* Note: Assumes SET DELETED ON and SET TALK OFF
* Returns logical

STORE .F. TO ab_exit, ab_enter  && to monitor exit mode from keyhandler
ab_return = .F.                 && default value to return

* Save environment
ab_cursor = SET("CURSOR")
ab_exact  = SET("EXACT")
ab_near   = SET("NEAR")
SET CURSOR OFF                  && to prevent it from jumping up&down
SET EXACT OFF                   && we'll seek just the first letter...
SET NEAR ON                     && ...in a 'softseek' manner

USE Customer ORDER Cust_code IN SELECT() 
SELECT("Customer")              && open and select lookup file
IF SEEK(Orders->ORD_CUST)       && seek the value first...
  ab_enter = .T.                && ..and set flag if found...
ELSE                            && not found...activate picklist...
  DEFI WIND Brow_1 FROM 5,21 TO 20,53
  ACTI WIND Brow_1              && define and activate window for BROWSE

  DO WHILE .NOT. ab_exit        && start pick list loop
    KEYBOARD CHR(27)            && force immediate exit from BROWSE
    BROWSE NOMENU  NOAPPEND NOEDIT NODELETE NOCLEAR COMPRESS ;
      LOCK 1 WINDOW Brow_1 ;
      FIELDS  cust_code, cust_name
    ab_press = ab_KeyH(13, "addOrd_c()", .T.)  && call keyhandler
  ENDDO                         && end of pick list loop
  RELEASE WINDOW Brow_1         && get rid of the BROWSE window

ENDIF

IF ab_enter                     && item selected by pressing RETURN
  ab_temp = Customer->Cust_code             && temporary variable...
  REPLACE Orders->Ord_cust WITH ab_temp     && replace field in Orders.dbf
  @ 3,21 GET ab_temp PICTURE "@! XXXXXXXXXX"&& display it on the screen...
  ab_return = .T.                           && set return value to .T.
ENDI

* Restore pre-browse state of things
USE
SET CURSOR &ab_cursor
SET NEAR &ab_near
SET EXACT &ab_exact
SELECT Orders

RETU ab_return                              && .T. or .F.

*-- EOF: CustCode


FUNCTION addOrd_c                          
* Append record(s) to lookup table Customer (if allowed...)
* Called by ab_keyH()
* Returns numeric

    KEYBOARD CHR(24)+"Y"              && put BROWSE in append mode
    ON KEY LABEL F9 KEYBOARD CHR(23)  && allow exit & save with 1 keystroke
    ab_acurs = SET("CURSOR")          && save set cursor state
    SET CURSOR ON

    BROWSE NOMENU NOFOLLOW COMPRESS LOCK 1 WINDOW Brow_1 ;
      FIELDS  cust_code, cust_name

    ON KEY LABEL F9                   && reset function key
    SET CURSOR &ab_acurs
    IF "" = LTRIM(RTRIM(cust_code))   && no need for empty values...
      DELETE
      RETURN RECN()-1                 && last not deleted record
    ENDIF
    RETURN RECN()                     && to move the record pointer

*-- EOF:addOrd_c


* FUNCTION Ab_keyH (ab_ToSkip, ab_ToDo, ab_Append)
* Keystroke handler for pseudo-browse
* Returns: numeric
* Parameters description:
* ab_ToSkip - number of record to skip based on the browse window height
*             type - numeric
* ab_ToDo   - UDF name to append (add) records to the lookup table
*             type - character string
* ab_Append - allow appending records to the lookup table?
*             type - logical
*
FUNCTION Ab_KeyH
PARAMETERS ab_ToSkip, ab_ToDo, ab_Append

  ab_press = 600                && ab_press receives value from INKEY(0)

  DO WHILE .T.                  && needed only for LOOP if keystroke not valid
    ab_press = INKEY(0)         && get the keystroke...
    CLEAR TYPEAHEAD             && ...just one keystroke...

    * process keystrokes
    DO CASE
    CASE ab_press = 13          && Enter
      * both ab_exit, ab_enter are defined in the calling procedure as .F.
      STORE .T. TO ab_exit, ab_enter
    CASE ab_press = 24          && Down Arrow
      IF .NOT. EOF()
        SKIP                    && skip only if not EOF()
      ENDIF
      IF RECN() > RECC()        && adjust for the 'phantom' record...
        SKIP - 1                && ...and skip back to the last record
        IF ab_append            && only if appending is allowed...
            ab_recn = &ab_ToDo  && append record(s) to the lookup table...
            GO ab_recn          && and go to last added record...
        ENDIF
      ENDIF
    CASE ab_press =  5          && Up Arrow
      IF .NOT. BOF()
        SKIP-1
      ENDIF
      IF BOF()                  && IF...ELSE doesn't seem to fit in here
        ?? CHR(7)               && attempt to skip beyond top of file - beep...
      ENDIF
    CASE ab_press = 18          && PgUp
      SKIP -ab_toskip           && retract record pointer by window height
    CASE ab_press =  3          && PgDn
      SKIP ab_toskip            && advance record pointer by window height...
      IF EOF()
        GO BOTT                 && ...and retract if skipped too much
      ENDIF
    CASE ab_press = 31          && Ctrl-PgUp
      GO TOP
    CASE ab_press = 30          && Ctrl-PgDn
      GO BOTT
    CASE ab_press = 27          && Esc
      ab_exit = .T.             && let's get out of the selection process

    *
    * Process the keystrokes with value from ASCII 48 through ASCII 122
    * separately...
    CASE ab_press >= 48 .AND. ab_press <= 122
      IF "" <> ORDER()
        SEEK CHR(ab_press)      && seek only if an index is active
      ELSE
        ?? CHR(7)               && beep at the user - index not active...
      ENDIF
    OTHERWISE                   && not a valid keystroke
      ?? CHR(7)                 && beep at the user...
      LOOP                      && get another keystroke
    ENDCASE
    EXIT                        && valid keystroke entered and processed
  ENDDO                         && exit DO WHILE...loop...
  RETURN ab_press               && return the keystroke

*-- End of procedure file ABP_ORDE.PRG

