 1 : /*  Name:     ArrayRef.prg
 2 :     Author:   Steve Straley
 3 :     Notice:   Copyright(c) - 1991 by Steve Straley -
 4 :               All Rights Reserved
 5 :     Date:     March 29, 1991
 6 :     Compile:  Clipper ArrayRef /m /p /v
 7 :     Version:  Clipper 5.01
 8 :     Link:     RTLink FI ArrayRef
 9 :     Note:     This example shows how to use the pre-processor
10 :               to emulate passing array subscripts by reference
11 :               and then how to actually do it.  
12 : */
13 : 
14 : #define pUP_ARROW 5
15 : #define pBLOCK "B"
16 : #define pTRUE .T.
17 : #define pFALSE .F.
18 : 
19 : #translate @@<exp> => {|x| IF(x=NIL, <exp>, <exp> := x) }
20 : 
21 : LOCAL array := {1,2,3}
22 : 
23 : CLS
24 : 
25 : @ 10,10 GET array[1] VALID Lookup( @@array[1] )
26 : @ 11,10 GET array[2] VALID Lookup( @@array[2] )
27 : @ 12,10 GET array[3] VALID Lookup( @@array[3] )
28 : READ
29 : 
30 : ********************
31 : 
32 : FUNCTION Lookup( value )
33 : 
34 :    LOCAL retval := pTRUE, choices := {2,4,6,8}, row := 7, ;
35 :          col := 35, option, x
36 : 
37 :    IF LASTKEY() != pUP_ARROW   //  Always plan escape routes!
38 : 
39 :       IF EMPTY( ASCAN(choices, IF(VALTYPE(value)=pBLOCK, ;
40 :                                   EVAL(value), value) ) )
41 : 
42 :          retval := pFALSE
43 : 
44 :           /* Next, I would use AEVAL() off of the array of 
45 :              choices; however, I can not put the command 
46 :              PROMPT in the code block that is evaluated, only 
47 :              functions and psuedo-functions.  Not wanting to 
48 :              introduce too many topics, the FOR ... NEXT loop 
49 :              is used. */
50 : 
51 :          screen := SAVESCREEN(7,35,MAXROW(),MAXCOL())
52 :          
53 :          FOR x := 1 TO LEN( choices )
54 :             @ row++,col PROMPT choices[x]
55 :          NEXT
56 :          MENU TO option
57 : 
58 :          IF !EMPTY( option )
59 :             IF VALTYPE( value ) = pBLOCK
60 :                EVAL( value, choices[option] )
61 :             ELSE
62 :                value := choices[option]
63 :             ENDIF
64 :          ENDIF
65 : 
66 :          RESTSCREEN(7,35,MAXROW(),MAXCOL(), screen)
67 : 
68 :       ENDIF
69 : 
70 :    ENDIF
71 : 
72 :    RETURN( retval )
73 : 
74 : * End of File

