 1 : /*  Name:     OnASetk.prg
 2 :     Author:   Steve Straley
 3 :     Notice:   Copyright(c) - 1991 by Steve Straley
 4 :               All Rights Reserved
 5 :     Date:     March 29, 1991
 6 :     Compile:  Clipper OnaSetk /m /v
 7 :     Version:  Clipper 5.01
 8 :     Link:     RTLink FI Setkey2
 9 :     Note:     This shows the use the SET KEY command in
10 :               Clipper 5.0/.01 technology  */
11 : 
12 : #define pTAB   9
13 : #define pTRUE  .T.
14 : #define pESC   27
15 : #define MESSAGE_ROW SET(_SET_MESSAGE)
16 : 
17 : 
18 : 
19 : #translate GetMessage(<exp>) => ;
20 :            ( SETPOS( MESSAGE_ROW, 0), ;
21 :              DEVOUT(PADC(<exp>, MAXCOL())), pTRUE )
22 : 
23 : LOCAL file, size
24 : 
25 : SETKEY( pTAB, {|| FilesOnDisk( @file, @size )} )
26 : 
27 : SET( _SET_MESSAGE, MAXROW() )
28 : 
29 : WHILE pTRUE
30 : 
31 :    CLS
32 : 
33 :    file := SPACE(40)
34 :    size := 0
35 : 
36 :    @ 1,0 SAY "Press TAB for Files!"
37 :    @ 3,0 SAY "Enter File Name: " GET file ;
38 :      WHEN GetMessage("Enter the File name")
39 :    @ 4,0 SAY "           Size: " GET size ;
40 :      WHEN GetMessage("Enter the appropriate DOS file size")
41 :    READ
42 : 
43 :    IF LASTKEY() != pESC
44 : 
45 :       @ 6,5 SAY "Values are: " GET file
46 :       @ 7,5 SAY "            " GET size
47 :       CLEAR GETS
48 :       WAIT
49 : 
50 :    ELSE
51 :       
52 :       EXIT
53 : 
54 :    ENDIF
55 : 
56 : ENDDO
57 : 
58 : ********************
59 : 
60 : FUNCTION FilesOnDisk( a, b )
61 : 
62 :    STATIC thefiles, thesizes
63 : 
64 :    LOCAL var, screen := SAVESCREEN( 4,40,20,60 )
65 : 
66 :    IF thefiles = NIL
67 :       /* both variables can not go to the same
68 :          array pointer because they are different! */
69 : 
70 :       thefiles := {}
71 :       thesizes := {} 
72 :       AEVAL( DIRECTORY(), {|x| AADD(thefiles, x[1]), ;
73 :                                AADD(thesizes, x[2]) } )
74 :    ENDIF
75 : 
76 :    @ 4,40 TO 20,60 DOUBLE
77 : 
78 :    var := ACHOICE(5,41,19,59,thefiles)
79 : 
80 :    IF !EMPTY(var)
81 :       a := PADR( thefiles[var], 40 )
82 :       b := thesizes[var]
83 :    ENDIF
84 : 
85 :    RESTSCREEN( 4, 40, 20, 60, screen )
86 : 
87 :    RETURN( NIL )
88 : 
89 : * End of File

